<template>
    <div class="details-list">
        <details-param-item v-for="(obj, key) in config" :ref="key" :key="key" class="details-list__item"
            :id="key" :config="itemConfig(key, obj)" :value="itemValue(key, obj)">
            <template v-slot:social_data>
                <social-data-table v-for="(social, index) in data.social_data" :key="index" :params="social" />
            </template>
        </details-param-item>
    </div>
</template>

<script>
import SocialDataTable from '@/components/tables/SocialData';
import DetailsParamItem from './DetailsParamItem';
import { basicEditParams } from '@/constants/ui/details';

export default {
    name: 'DetailsParamList',
    components: {
        DetailsParamItem,
        SocialDataTable,
    },
    props: {
        config: { // design config
            type: Object,
            required: false,
        },
        data: { // user data from server
            type: Object,
            required: false,
        },
    },
    computed: {
        itemValue: vm => (key, conf) => {
            if (conf.complex) {
                const dataObj = {};
                // complex structure from server
                if (conf.complex.base && conf.complex.field) {
                    return vm.data[conf.complex.base][conf.complex.field];
                }
                dataObj[key] = vm.data[key]; // 'invite from' case
                if (conf.complex.url) {
                    dataObj[conf.complex.url] = vm.data[conf.complex.url];
                }
                return dataObj;
            }
            return vm.data[key];
        },
        itemConfig: () => (key, conf) => {
            const editParams = basicEditParams[key];
            return editParams ? { ...conf, ...editParams } : conf;
        },
    },
    methods: {
        /** Discard changes for edited items */
        discardChanges() {
            Object.values(this.$refs).forEach(([el]) => {
                el.$refs.switcher.switchEditMode({ status: false });
            });
            this.$store.commit('clearEditedBasics');
        },
    },
};
</script>

<style lang="stylus" scoped>
.details-list__item
    margin-bottom: .5rem
    background-color: $bg_light_gray
</style>
